# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ambient_backend_api_client.models.notification_severity_enum import NotificationSeverityEnum
from ambient_backend_api_client.models.owner_type_enum import OwnerTypeEnum
from ambient_backend_api_client.models.resource_type_enum import ResourceTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class Notification(BaseModel):
    """
    Notification
    """ # noqa: E501
    name: StrictStr
    resource_type: Optional[ResourceTypeEnum] = None
    identifier: Optional[StrictStr] = None
    owner_id: Optional[StrictStr] = None
    owner_type: Optional[OwnerTypeEnum] = None
    description: Optional[StrictStr] = None
    requests: Optional[List[StrictStr]] = None
    notifications: Optional[List[StrictStr]] = None
    message: StrictStr
    severity: NotificationSeverityEnum
    target_resource_id: StrictStr
    target_resource_type: ResourceTypeEnum
    timestamp: StrictInt
    read: Optional[StrictBool] = False
    __properties: ClassVar[List[str]] = ["name", "resource_type", "identifier", "owner_id", "owner_type", "description", "requests", "notifications", "message", "severity", "target_resource_id", "target_resource_type", "timestamp", "read"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Notification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if identifier (nullable) is None
        # and model_fields_set contains the field
        if self.identifier is None and "identifier" in self.model_fields_set:
            _dict['identifier'] = None

        # set to None if owner_id (nullable) is None
        # and model_fields_set contains the field
        if self.owner_id is None and "owner_id" in self.model_fields_set:
            _dict['owner_id'] = None

        # set to None if owner_type (nullable) is None
        # and model_fields_set contains the field
        if self.owner_type is None and "owner_type" in self.model_fields_set:
            _dict['owner_type'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Notification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "resource_type": obj.get("resource_type"),
            "identifier": obj.get("identifier"),
            "owner_id": obj.get("owner_id"),
            "owner_type": obj.get("owner_type"),
            "description": obj.get("description"),
            "requests": obj.get("requests"),
            "notifications": obj.get("notifications"),
            "message": obj.get("message"),
            "severity": obj.get("severity"),
            "target_resource_id": obj.get("target_resource_id"),
            "target_resource_type": obj.get("target_resource_type"),
            "timestamp": obj.get("timestamp"),
            "read": obj.get("read") if obj.get("read") is not None else False
        })
        return _obj


